Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!

Bug 915136

Summary: sys-apps/portage: AsyncFunction should support multiprocessing.Pipe instead of fd_pipes to get function result
Product: Portage Development Reporter: Zac Medico <zmedico>
Component: CoreAssignee: Portage team <dev-portage>
Status: RESOLVED FIXED    
Severity: normal Keywords: InVCS
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: All   
See Also: https://github.com/gentoo/portage/pull/1111
https://bugs.gentoo.org/show_bug.cgi?id=916116
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on: 915120    
Bug Blocks: 914876    

Description Zac Medico gentoo-dev 2023-10-03 20:01:09 UTC
Since fd_pipes does not work with the multiprocessing spawn start method, AsyncFunction should use multiprocessing.Pipe instead (see bug 915123 comment #0 for example).
Comment 1 Larry the Git Cow gentoo-dev 2023-10-04 01:06:32 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/proj/portage.git/commit/?id=1c0b5ff6aabe99224b07f7fc2e09e4cb6c9c70c4

commit 1c0b5ff6aabe99224b07f7fc2e09e4cb6c9c70c4
Author:     Zac Medico <zmedico@gentoo.org>
AuthorDate: 2023-10-03 20:33:18 +0000
Commit:     Zac Medico <zmedico@gentoo.org>
CommitDate: 2023-10-04 00:47:01 +0000

    AsyncFunction: Use multiprocessing.Pipe for compat with multiprocessing spawn
    
    Since fd_pipes does not work with the multiprocessing spawn start
    method, AsyncFunction should use multiprocessing.Pipe instead.
    
    Bug: https://bugs.gentoo.org/915136
    Signed-off-by: Zac Medico <zmedico@gentoo.org>

 lib/portage/tests/process/test_AsyncFunction.py | 34 ++++++++++++++++---------
 lib/portage/util/_async/AsyncFunction.py        | 15 +++++++----
 2 files changed, 32 insertions(+), 17 deletions(-)
Comment 2 Larry the Git Cow gentoo-dev 2023-10-20 00:51:24 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=3500483f75789c36e379c1b6546a09df7c11e2b1

commit 3500483f75789c36e379c1b6546a09df7c11e2b1
Author:     Sam James <sam@gentoo.org>
AuthorDate: 2023-10-20 00:49:33 +0000
Commit:     Sam James <sam@gentoo.org>
CommitDate: 2023-10-20 00:51:00 +0000

    sys-apps/portage: add 3.0.53
    
    Closes: https://bugs.gentoo.org/915120
    Closes: https://bugs.gentoo.org/821529
    Closes: https://bugs.gentoo.org/914441
    Closes: https://bugs.gentoo.org/914722
    Closes: https://bugs.gentoo.org/914873
    Closes: https://bugs.gentoo.org/915099
    Closes: https://bugs.gentoo.org/915123
    Closes: https://bugs.gentoo.org/915128
    Closes: https://bugs.gentoo.org/915136
    Closes: https://bugs.gentoo.org/915330
    Closes: https://bugs.gentoo.org/915494
    Closes: https://bugs.gentoo.org/915834
    Closes: https://bugs.gentoo.org/915903
    Closes: https://bugs.gentoo.org/900224
    Signed-off-by: Sam James <sam@gentoo.org>

 sys-apps/portage/Manifest              |   1 +
 sys-apps/portage/portage-3.0.53.ebuild | 238 +++++++++++++++++++++++++++++++++
 2 files changed, 239 insertions(+)